//Group 10 Sick Birdz
//Thanks to group 7 for the bird info
//reference: by Joël Gähwiler, https://github.com/256dpi/processing-mqtt

import mqtt.*;

Backdrop backdrop;
MQTTClient client;
Adapter adapter;

String lE;                          //last Event
boolean event = false;              //starting value
boolean up = false;
boolean down = false;
int timeSlider = 1;                 //switch to scroll in history
int hits;                           //is how many birds are there during a certain time
int x = 1;                          //x = 1 so we can request the first event
int y = 1;                          //This is the value of what event I ask for when you sroll back in time
float[] numb = new float[5];        //the array of numbers we get from the beacon is made up out of 5 numbers
float b1;                           //beacon 1
float b2;                           //beacon 2
float b3;                           //beacon 3
float day;
float time;

class Adapter implements MQTTListener {
  void clientConnected() {
    println("client connected");
    client.subscribe("catTrack/nE");
    client.subscribe("catTrack/rq/LE");
    client.subscribe("birdData/hits");
  }

  void messageReceived(String topic, byte[] payload) {
    println("new message: " + topic + " - " + new String(payload));
    String message = new String(payload);
    if (topic.equals("catTrack/nE") && message.equals("1")) {              //if newEvent(nE) is 1 ->
      event = true;                                                        //thus true
      client.publish("catTrack/nE", "0");                                  //make newEvent 0 again, because we the information of the latest event now
    }

    if (topic.equals("birdData/hits")) {
      hits = int(message);
      println("birds" + " " + hits);
    }

    if (topic.equals("catTrack/rq/LE")) {                                  //if the topic of the requested information is lastEvent
      client.publish("birdData/rq", "" + str(round(numb[3])) + " " + str(round(numb[2])) + "");    //we publishe the date and time of which we want the bird data.
      numb = float(split(message, ','));                                   //here we split the number we get in the from of [0000 000 000000 000] into seperate numbers
      println(numb[0], numb[1], numb[2], numb[3], numb[4]);

      if (y == x) {
        if (numb[1] == 1) {                                                //if the wanted ID has number 1 ->
          b1 = b1 + (numb[4]/100);                                         //we make the radian and the opacity of beacon 1 bigger
          day = numb[3];
          time = numb[2];
          // println("b1", b1);
        }
        if (numb[1] == 2) {                                                //if the wanted ID has number 2 ->
          b2 = b2 + (numb[4]/100);                                         //we make the radian and the opacity of beacon 2 bigger
          day = numb[3];
          time = numb[2];
          // println("b2", b2);
        }

        if (numb[1] == 3) {                                                //if the wanted ID has number 3 ->
          b3 = b3 + (numb[4]/100);                                         //we make the radian and the opacity of beacon 3 bigger
          day = numb[3];
          time = numb[2];
          //println("b3", b3);
        }
      } else {
        if (numb[1] == 1) {                                                //if the wanted ID has number 1 ->
          b1 = b1 - timeSlider*(numb[4]/100);                              //we make the radian and the opacity of beacon 1 smaller/bigger
          day = numb[3];
          time = numb[2];
          // println("b1", b1);
        }
        if (numb[1] == 2) {                                                //if the wanted ID has number 2 ->
          b2 = b2 - timeSlider*(numb[4]/100);                              //we make the radian and the opacity of beacon 2 smaller/bigger
          day = numb[3];
          time = numb[2];
          // println("b2", b2);
        }

        if (numb[1] == 3) {                                                //if the wanted ID has number 3 ->
          b3 = b3 - timeSlider*(numb[4]/100);                              //we make the radian and the opacity of beacon 3 smaller/bigger
          day = numb[3];
          time = numb[2];
          //println("b3", b3);
        }
      }
    }
  }

  void connectionLost() {
    println("connection lost");
  }
}

void setup() {
  //size(800, 800);
  fullScreen();
  backdrop = new Backdrop(width/2, height/2);
  adapter = new Adapter();
  client = new MQTTClient(this, adapter);
  client.connect("mqtt://test.mosquitto.org:1883");
}

void draw() {
  background(255);
  backdrop.backdrop();

  if (event) {                                    //if event is true ->
    client.publish("catTrack/rq/wID", str(x));    //we ask for the wanted ID (cats)
    x++;                                          // x++ so we always ask for the latest ID which is the one we want for the heat map
    y = x;                                        //this is to be able to scroll through the timeline
    event = false;                                //make event false again so we can de this all over again
  }

  //BEACON 1
  fill(255, 0, 0);
  text("1", 926, 220);
  circle(1073, 220, 10);                //place beacon 1
  stroke(0);
  noFill();
  circle(1073, 220, 250);
  noStroke();

  if (b1<80) {
    fill(255, 15, 15, 2*b1);
  } else {
    fill(255, 15, 15, 80);
  }

  if (b1<250) {
    circle(1073, 220, 15 + b1);
  } else {
    circle(1073, 220, 250);
  }

  if (0.3*b1<250) {
    if (b1>=150) {
      fill(205, 15, 15);
      circle(1073, 220, 10 + 0.3*b1);
    }
  } else {
    fill(205, 15, 15);
    circle(1073, 220, 250);
  }

  if (0.2*b1<250) {
    if (b1>=200) {
      fill(185, 10, 15);
      circle(1073, 220, 10 + 0.2*b1);
    }
  } else {
    fill(185, 10, 15);
    circle(1073, 220, 250);
  }


  //BEACON 2
  fill(255, 0, 0);
  text("2", 500, 473);
  circle(646, 473, 10);                //place beacon 2
  stroke(0);
  noFill();
  circle(646, 473, 250);
  noStroke();

  if (b2<80) {
    fill(255, 15, 15, 2*b2);
  } else {
    fill(255, 15, 15, 80);
  }

  if ( b2<250) {
    circle(646, 473, 15 + b2);
  } else {
    circle(646, 473, 250);
  }

  if (0.3*b2<250) {
    if (b2>=150) {
      fill(205, 15, 15);
      circle(646, 473, 10 + 0.3*b2);
    }
  } else {
    fill(205, 15, 15);
    circle(646, 473, 250);
  }

  if (0.2*b2<250) {
    if (b2>=200) {
      fill(185, 10, 15);
      circle(646, 473, 5 + 0.2*b2);
    }
  } else {
    fill(185, 10, 15);
    circle(646, 473, 250);
  }


  //BEACON 3
  fill(255, 0, 0);
  text("3", 1153, 736 );
  circle(1302, 736, 10);                 //place beacon 3
  stroke(0);
  noFill();
  circle(1302, 736, 250);
  noStroke();

  if (b3<80) {
    fill(255, 15, 15, 2*b3);
  } else {
    fill(255, 15, 15, 80);
  }

  if (b3<250) {
    circle(1302, 736, 15 + b3);
  } else {
    circle(1302, 736, 250);
  }

  if (0.3*b3<250) {
    if (b3>=150) {
      fill(205, 15, 15);
      circle(1302, 736, 10 + 0.3*b3);
    }
  } else {
    fill(205, 15, 15);
    circle(1302, 736, 250);
  }

  if (0.2*b3<250) {
    if (b3>=200) {
      fill(185, 10, 15);
      circle(1302, 736, 10 + 0.2*b3);
    }
  } else {
    fill(185, 10, 15);
    circle(1302, 736, 250);
  }


  //Day and Time
  stroke(0);
  fill(180, 180, 180);
  rect(0, 0, 423.5, 118);
  fill(0);
  textSize(40);
  text("Day:", 10, 50);
  text("Hour:", 10, 90);
  text(int(day), 115, 52);                        //Day -->
  text(nf(time, 0, 1), 115, 90);                  //and Time of the latest/requested measurement


  //go back up to the real time
  if (up) {
    y = y+1;
    println(y);
    client.publish("catTrack/rq/wID", str(y));    //we ask for the wanted ID

    up = false;                                   //make up false again so we can de this all over again
  }


  //go back in time
  if (down) {
    y = y-1;
    println(y);
    client.publish("catTrack/rq/wID", str(y));    //we ask for the wanted ID

    down = false;                                 //make down false again so we can de this all over again
  }


  //Latest detection
  textSize(30);
  text("Latest detection:", 10, 600);
  if (y == x) {
    text("Beacon" + " " + int(numb[1]), 223, 600);
  }


  //BIRDS
  textSize(40);
  text("Rangers Tweak ", 1510, 250);
  text("is at beacon:", 1510, 300);
  if (x<=11) {
    text("1", 1730, 300);
  } else {
    text("2", 1730, 300);
  }
  text("Amount of birds", 1510, 400);
  text("detected:", 1510, 450);
  text(hits, 1680, 450);


  //BUTTONS
  fill(180, 180, 180, 70);
  rect(100, 775, 50, 50);
  fill(180, 180, 180);
  triangle(100, 800, 150, 800, 125, 775 );
  rect(117.5, 800, 15, 25);
  fill(0);
  text("Up", 160, 815);

  fill(180, 180, 180, 70);
  rect(100, 875, 50, 50);
  fill(180, 180, 180);
  triangle(100, 900, 150, 900, 125, 925 );
  rect(117.5, 875, 15, 25);
  fill(0);
  text("Down", 160, 915);

  if (y == 1) {
    textSize(27);
    fill(0);
    text("You are at the beginning", 100, 950);
  }

  if (y == x) {
    textSize(27);
    fill(0);
    text("You are at the present", 100, 765);
  }
}

void keyPressed() {
  if (y<x) {
    if (keyCode == UP) {
      up = true;
      timeSlider = -1;                      //makes sure we go back up in time
    }
  }

  if (y>1) {
    if (keyCode == DOWN) {
      down = true;
      timeSlider = 1;                       //makes sure we can go back in time
    }
  }
}
