/*
 * This ESP32 code is created by esp32io.com and modified by Christopher Nase
 *
 */

#define beaconOne 34 // ESP32 pin 32 works with wifi? (ADC0)
#define beaconTwo 33 // ESP32 pin 33
#define beaconThree 35

#include "WiFi.h"
#include <PubSubClient.h>
#include <Wire.h>
#include <SPI.h>
#include "printf.h"
#include "RF24.h"


//Wifi Login
const char* ssid = "Christopher's Iphone";
const char* password = "banana123";

const char* mqtt_server = "test.mosquitto.org";

WiFiClient espClient;
PubSubClient client(espClient);

//Used for indexing the time
int dateTotal = 0;
int day = 0;
int hour = 0;
double hoursInDay = 24;
String message = "";
String currentDate = "";

void setup_wifi() {
  delay(10);
  // We start by connecting to a WiFi network
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);

  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }

  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
}

void setup() {
  // initialize serial communication at 9600 bits per second:
  Serial.begin(9600);
  //MQTT WiFi setup
  setup_wifi();
  client.setServer(mqtt_server, 1883);
}

void loop() {

  if (!client.connected()) {
    reconnect();
  }
  client.loop();

  int sensorOne = analogRead(beaconOne);
  int sensorTwo = analogRead(beaconTwo);
  //Serial.println(sensorOne);
  if (sensorOne < 1000 && sensorOne != 0) {
    message = "";
    message.concat(currentDate);
    message += ",";
    message += 1;
    message += ",";
    message += 1;
    message += ",";
    message += 300;
    Serial.println(message);
    char Buf[20];
    message.toCharArray(Buf,20);
    client.publish("esp32test/sendto", Buf);
  }
  Serial.println(sensorTwo);
  if (sensorTwo < 1200 && sensorTwo != 0){
    message = "";
    message.concat(currentDate);
    message += ",";
    message += 1;
    message += ",";
    message += 2;
    message += ",";
    message += 300;
    Serial.println(message);
    char Buf[20];
    message.toCharArray(Buf,20);
    client.publish("esp32test/sendto", Buf);
  }

  //DateMaker
  dateTotal = dateTotal + 1;
  day = round(dateTotal/24)+1;
  hour = (dateTotal%24)+1;
  currentDate = "";
  currentDate += "'";
  currentDate += day;
  currentDate += " ";
  currentDate += hour;
  currentDate += "'";

  delay(2000);
}

void reconnect() {
  // Loop until we're reconnected
  while (!client.connected()) {
    Serial.print("Attempting MQTT connection...");
    // Attempt to connect
    if (client.connect("ESP32Client")) {
      Serial.println("connected");
      // Subscribe
    } else {
      Serial.print("failed, rc=");
      Serial.print(client.state());
      Serial.println(" try again in 5 seconds");
      // Wait 5 seconds before retrying
      delay(5000);
    }
  }
}