/*
This code is used within the CatTrack collars,  an arduino nano is connected to an nRF24 for transmission purposes
Be sure that the collars and beacon use the same RF address
 */

//#include <SPI.h>
#include "printf.h"
#include "RF24.h"


RF24 radio(6, 7);  // using pin 7 for the CE pin, and pin 8 for the CSN pin

uint64_t address[6] = { 0x7878787878LL,
                        0xB3B4B5B6F1LL,
                        0xB3B4B5B6CDLL,
                        0xB3B4B5B6A3LL,
                        0xB3B4B5B60FLL,
                        0xB3B4B5B605LL };



char role = 1;

struct PayloadStruct {
  unsigned long nodeID;
  unsigned long payloadID;
};

PayloadStruct payload;

void setRole();

void setup() {

  Serial.begin(115200);
  while (!Serial) {
  }

  if (!radio.begin()) {
    Serial.println(F("radio hardware is not responding!!"));
  }

  Serial.println(F("RF24/examples/MulticeiverDemo"));
  Serial.println(F("*** Enter a number between 0 and 5 (inclusive) to change"));
  Serial.println(F("    the identifying node number that transmits."));
  radio.begin();
  radio.setPALevel(RF24_PA_LOW);
  radio.setPayloadSize(sizeof(payload));
  setRole();
printf_begin();
radio.printPrettyDetails(); // (larger) function that prints human readable data
}  // setup()

void loop() {

  if (role <= 53) {
    int trigState = 0;
   for(int i = 1; i<102 ; i++){ //In order to calculate the signal strength of the transmitter, it sends payloads ranging from 1 to 100 and then 2 points to reset it
    unsigned long start_timer = micros();                 
    bool report = radio.write(&payload, sizeof(payload)); 
    unsigned long end_timer = micros();                    
 
    if (report) {
      Serial.print(payload.payloadID);
      Serial.println(payload.nodeID);
    } else {
      Serial.println(F("Transmission failed or timed out"));
    }
    if(payload.payloadID < 100 && trigState == 0){
    payload.payloadID++;  // increment payload number
    }
    else{
      trigState = 1;
      payload.payloadID = 0;
    }
    delay(200);
    }
    delay(8000);
    payload.payloadID = 1;
  }
}  // loop

void setRole() {
    payload.nodeID = 1;
    payload.payloadID = 0;
    radio.stopListening();
    radio.openWritingPipe(0xB3B4B5B605LL);
    radio.setRetries(((role * 3) % 12) + 3, 15);
}  // setRole
